/*
   Copyright (c) 2012 Emitrom LLC. All rights reserved. 
   For licensing questions, please contact us at licensing@emitrom.com

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.
 */

package com.emitrom.lienzo.client.core.event;

import com.emitrom.lienzo.client.widget.DragContext;

public class NodeDragStartEvent extends AbstractNodeDragEvent<NodeDragStartHandler>
{
    private static final Type<NodeDragStartHandler> TYPE = new Type<NodeDragStartHandler>();

    public static Type<NodeDragStartHandler> getType()
    {
        return TYPE;
    }

    public NodeDragStartEvent(DragContext dragContext)
    {
        super(dragContext);
    }

    @Override
    public final Type<NodeDragStartHandler> getAssociatedType()
    {
        return TYPE;
    }

    @Override
    protected void dispatch(NodeDragStartHandler handler)
    {
        handler.onNodeDragStart(this);
    }
}
